import ea.*;
public class MeinSpiel
extends Game
implements TastenGedruecktReagierbar
{
    private static final int ANZAHL = 100;
    private Figur spieler;
    private Bild wiese;
    private Bild[] hindernis;
    private Bild block;
    private Bild block2;
    private Bild block3;
    private Bild ziel;
    private boolean nachrechts;
    private Rechteck boden;
    private Sound sound;
    
    public MeinSpiel()
    {
        super (800, 450);
        super.tastenGedruecktReagierbarAnmelden(this);
        wiese = new Bild (0,0, "wiese.gif");
        sichtbarMachen(wiese);
        boden = new Rechteck(0,415,800,10);
        sichtbarMachen(boden);
        boden.passivMachen();
        ziel = new Bild (750,370, "ziel2.gif");
        sichtbarMachen(ziel);
        spieler = new Figur (10, 375, "spieler2.eaf");
        sichtbarMachen(spieler);
        spieler.aktivMachen();
        block = new Bild (150,370, "block2.gif");
        sichtbarMachen(block);
        block.passivMachen();
        block2 = new Bild (350,370, "block2.gif");
        sichtbarMachen(block2);
        block2.passivMachen();
        block3 = new Bild (550,370, "block2.gif");
        sichtbarMachen(block3);
        block3.passivMachen();
        nachrechts = true;
        hindernis = new Bild[ANZAHL];
        for (int i=0; i<ANZAHL; i++)
        {
            int x,y;
            x = zufallsZahl(800);
            y=-50-i*150;
            hindernis[i] = new Bild (x,y, "tannenzapfen.gif");
            animationsManager.geradenAnimation(hindernis[i], new Punkt (x,900),5000+i*350,5000+i*350);
            sichtbarMachen(hindernis[i]);
        }
        sound = new Sound ("sound001.wav");
        audioManager.abspielen(sound, true);
        MeinTicker ticker = new MeinTicker(this);
        manager.anmelden(ticker,250);
    }

    public void tasteReagieren(int tastenCode) 
    {
        if (tastenCode == 1)
        {
            System.exit(0);
        }
        
        if (tastenCode == 27)
        {
            spieler.bewegen(5,0);
            if (nachrechts != true)
            {
                spieler.spiegelYSetzen(false);
                nachrechts = true;
            }
        }
        
        if (tastenCode == 29)
        {
            spieler.bewegen(-5,0);
            if (nachrechts == true) 
            {
                spieler.spiegelYSetzen(true);
                nachrechts = false;
            }
        }
        
        if (tastenCode == 30)
        {
            spieler.sprung(5);
        }
    }
    
    public void tasteGedrueckt(int tastenCode)
    {
         if (tastenCode == 27)
        {
            spieler.bewegen(5,0);
        }
        
        if (tastenCode == 29)
        {
            spieler.bewegen(-5,0);
        }
    }
    
    public void sichtbarMachen(Raum m)
    {  
        wurzel.add(m);
    }
    
    public boolean kollisionstestZapfen()
    {
        boolean treffer = false;
        for (int i=0; i<ANZAHL; i++)
        {
            if (spieler.schneidet(hindernis[i])==true)
            {
                treffer=true;
            }
        }
        return treffer;
    }
    
    public boolean kollisionstestTuer()
    {
        boolean treffer = false;
        if (spieler.schneidet(ziel)==true)
        {
            treffer=true;
        }
        return treffer;
    }
    
    public void gameover()
    {
        wurzel.leeren();
        Text T1 = new Text("GAME OVER!",300,100,"Arial",26,0,"Rot");
        Text T2 = new Text("Zum beenden bitte 'B' drücken",300,130, "Arial", 12,0, "Rot");
        sichtbarMachen(T1);
        sichtbarMachen(T2);
    }
    
    public void gewonnen()
    {
        wurzel.leeren();
        Text T3 = new Text("Herrzlichen Glückwunsch !", 300, 100, "Arial", 26,0,"Blau");
        Text T4 = new Text("Sie haben gewonnen :)", 300, 130, "Arial", 12,0, "Blau");
        Text T5 = new Text("Zum beenden bitte 'B' drücken",300,150, "Arial", 12,0, "Blau");
        sichtbarMachen(T3);
        sichtbarMachen(T4);
        sichtbarMachen(T5);
    }
}